{
  "openapi": "3.0.0",
  "info": {
    "title": "Vistar Media Marketplace DSP API",
    "description": "The DSP (Demand Side Platform) API lets you view, create, and update insertion orders, campaigns, and related data.",
    "version": null
  },
  "servers": [
    {
      "url": "https://platform-api.vistarmedia.com/api/dsp/v1"
    }
  ],
  "security": [
    {
      "SessionCookie": []
    }
  ],
  "tags": [
    {
      "name": "Insertion Orders",
      "description": "Insertion orders represent a contractual agreement between the buyer and the media owner. Each insertion order is associated with a single advertiser and contains one or more campaigns (line items). These campaigns divide the insertion order budget and define targeting and other business rules. Using this API, you can list, view, create, and update insertion orders."
    },
    {
      "name": "Campaigns",
      "description": "Campaigns  are the individual line items that belong to an insertion order. You can apply targeting and associate creatives with campaigns. Each creative is associated with a single creative category. Using this API, you can list, view, create, modify, and activate campaigns."
    },
    {
      "name": "Targeting",
      "description": "In Vistar’s DSP, you can add targeting to run your campaigns on different formats and locations of DOOH (digital out-of-home) inventory. You can layer multiple targeting options on your campaigns to reach specific inventory.\n\nTargeting using the DSP API currently supports only venue, venue type, publisher, and deal targeting. Other targeting options will follow.\n\nYou can see a campaign’s current targeting using the [Get Campaign Targetings API](/apis/dsp/targeting/dsp_getcampaigntargetings) and set targetings on a campaign using the [Set Campaign Targetings API](/apis/dsp/targeting/dsp_setcampaigntargetings)."
    },
    {
      "name": "Advertisers",
      "description": "An advertiser identifies the brand or organization associated with an insertion order or creative. Using this API, you can list and create advertisers.\n\nAdvertisers in the Vistar DSP are global and shared across all seats and users."
    },
    {
      "name": "Creatives",
      "description": "Creatives are the images, videos, audio, and dynamic assets that make up your campaign. Using the DSP API, you can view creatives, update creative metadata, and associate existing creatives with campaigns and insertion orders.\n\nCreatives are specific to each DSP seat. Each creative can be associated with multiple campaigns across multiple insertion orders. When a creative is associated with a campaign, it must also be associated with the campaign’s parent insertion order. The API automatically creates this association if needed.\n\nEach creative is associated with an advertiser and assigned a creative category. Use the [Advertiser](/apis/dsp/advertisers) and [Creative Category](/apis/dsp/creatives/dsp_listcreativecategories) APIs to find the applicable advertiser and creative category IDs. The creative’s advertiser ID must match the campaign and insertion order during association."
    }
  ],
  "paths": {
    "/advertisers": {
      "get": {
        "summary": "List Advertisers",
        "description": "Returns the global list of advertisers available to all seats in the DSP.",
        "operationId": "DSP_ListAdvertisers",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.ListAdvertisersResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64",
              "minimum": 0,
              "maximum": 100,
              "default": 25
            },
            "description": "The maximum number of results to return per page."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64",
              "minimum": 0,
              "default": 0
            },
            "description": "The zero-based page offset (page number ) to return. For example, 0 returns the first page, 1 returns the second page, and so on."
          },
          {
            "name": "order",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            },
            "description": "The field to sort the results by."
          },
          {
            "name": "asc",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean",
              "default": false
            },
            "description": "Specifies the sort direction. Set to `true` for ascending order or `false` for descending order."
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "The field to filter by. You can specify multiple filter parameters.\n\nWhen you apply filters to different fields, the results include only records that match all specified field values (AND logic). When you apply multiple filters to the same field, the results include records that match any of the specified values in that field (OR logic).\n\nSupported Fields: `id`.",
            "example": "id:000lYW0SSFSPuV32udyVpA"
          },
          {
            "name": "search",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "Perform a substring search on the specified field. Searches are case-insensitive.\n\nSupported Fields: `name`.",
            "example": "name:duff"
          }
        ],
        "tags": [
          "Advertisers"
        ]
      },
      "post": {
        "summary": "Create Advertiser",
        "description": "Create a new Advertiser",
        "operationId": "DSP_CreateAdvertiser",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Advertiser"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.CreateAdvertiserRequest"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Advertisers"
        ]
      }
    },
    "/advertisers/{id}": {
      "get": {
        "summary": "Get Advertiser by ID",
        "description": "Returns an individual advertiser.",
        "operationId": "DSP_GetAdvertiser",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Advertiser"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "tags": [
          "Advertisers"
        ]
      }
    },
    "/campaigns": {
      "get": {
        "summary": "List Campaigns",
        "description": "Returns a list of the seat's campaigns, optionally with progress information.",
        "operationId": "DSP_ListCampaigns",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.ListCampaignsResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "The maximum number of results to return per page."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "The zero-based page offset (page number ) to return. For example, 0 returns the first page, 1 returns the second page, and so on."
          },
          {
            "name": "order",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            },
            "description": "The field to sort the results by."
          },
          {
            "name": "asc",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean"
            },
            "description": "Specifies the sort direction. Set to `true` for ascending order or `false` for descending order."
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "The field to filter by. You can specify multiple filter parameters.\n\nWhen you apply filters to different fields, the results include only records that match all specified field values (AND logic). When you apply multiple filters to the same field, the results include records that match any of the specified values in that field (OR logic).\n\nSupported Fields: `id`, `archived`, `insertion_order_id`, `region_code`, `active`, `pacing`, `buy_type`\n\nSpecial Filters: `in_flight`: When `true`, limits results to campaigns where the current time falls between `start_time` and `end_time`.",
            "example": "in_flight:true"
          },
          {
            "name": "search",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "Performs a substring search on a specified field. The search is case-insensitive.\n\nSupported Fields: `name`",
            "example": "name:quarter"
          },
          {
            "name": "view",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "BASIC",
                "PROGRESS"
              ],
              "default": "BASIC"
            },
            "description": "Specifies which fields are returned in the response.\n\nAvailable Views:\n\n- `BASIC`: Returns campaign metadata  only.\n- `PROGRESS`: Returns campaign metadata and current campaign progress information."
          }
        ],
        "tags": [
          "Campaigns"
        ]
      },
      "post": {
        "summary": "Create Campaigns",
        "description": "Create up to 100 new campaigns in a single request. Campaigns must be associated with insertion orders, so create the insertion orders first.\n\nThis endpoint is transactional. If the request succeeds, all campaigns are created. If the request fails, no campaigns are created.",
        "operationId": "DSP_CreateCampaigns",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CreateCampaignsResponse"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.CreateCampaignsRequest"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Campaigns"
        ]
      },
      "patch": {
        "summary": "Update Campaigns",
        "description": "Update up to 100 campaigns in a single request. Specify only the properties you want to update. Properties you omit remain unchanged.\n\nThis endpoint is transactional. If the request succeeds, all campaigns are updated. If the request fails, no campaigns are updated.",
        "operationId": "DSP_UpdateCampaigns",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.UpdateCampaignsResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.UpdateCampaignsRequest"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Campaigns"
        ]
      }
    },
    "/campaigns/{campaign_id}/targetings": {
      "get": {
        "summary": "Get Campaign Targetings",
        "description": "Returns a list of a campaign's active targetings. For targetings that the DSP API supports, the response includes full details in the appropriate options field. For unsupported targetings, the response includes only a targeting\\_type, with no details.\n\nTo view these details, log in to the Vistar DSP at [trafficking.vistarmedia.com](https://trafficking.vistarmedia.com/).",
        "operationId": "DSP_GetCampaignTargetings",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CampaignTargetings"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "campaign_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "tags": [
          "Targeting"
        ]
      },
      "put": {
        "summary": "Set Campaign Targetings",
        "description": "Set targetings on a campaign.\n\nTo set targetings, provide a list of targeting option objects in the targetings field. Each object represents a single targeting type. When you set a campaign's targetings using this API, the new values replace all existing targetings.\n\nIn each option, a venue is targeted when it meets any of the conditions (OR logic). When you include multiple targeting options, a venue is targeted only when it meets the conditions of all the options (AND logic).\n\nExample:\n\n```json\n{\n  \"targetings\": [\n    {\n      \"deal_targeting_option\": {\n        \"deal_ids\": [\n          \"OaQqQrsnSIS89FkQFzrR3w\",\n          \"w7_lwxwiSl6Kwg_tUxIXkA\",\n          \"4LLHNrnvTTWD4I3XG0TNHw\"\n        ]\n      }\n    },\n    {\n      \"venue_type_targeting_option\": {\n        \"venue_type_ids\": [\n          \"1\",\n          \"3\"\n        ],\n        \"exclude\": false\n      }\n    },\n    {\n      \"venue_targeting_option\": {\n        \"venue_targeting_ids\": [\n          \"tVcQWUFuTJ2OAr88vwi-Dg-XN3GJTIIOI\",\n          \"tVcQWUFuTJ2OAr88vwi-Dg-MHIYWB5RHX\",\n          \"7rLsD2w8SfmOwNGotS4o_g-NYC9093RD\"\n        ],\n        \"exclude\": true\n      }\n    }\n  ]\n}\n```\n\nIn this example, the campaign will target venues that are:\n\n- included in any of the three deal IDs\n- AND are in the Transit (1) OR Outdoor (3) venue type categories\n- AND is NOT any of the two specific venues specified\n\nTo remove all of a campaign’s targetings, send an empty list in the targetings field:\n\n```json\n{\n  \"targetings\": []\n}\n```\n\n{% admonition type=\"info\" %}\n**Note:** You can't remove targetings from an activated campaign.\n{% /admonition %}",
        "operationId": "DSP_SetCampaignTargetings",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CampaignTargetings"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "campaign_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.DSP.SetCampaignTargetingsBody"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Targeting"
        ]
      }
    },
    "/campaigns/{id}": {
      "get": {
        "summary": "Get Campaign by ID",
        "description": "Returns an individual campaign, optionally with progress information.",
        "operationId": "DSP_GetCampaign",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Campaign"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "view",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "BASIC",
                "PROGRESS"
              ],
              "default": "BASIC"
            },
            "description": "Specifies which fields are returned in the response.\n\nAvailable Views:\n\n- `BASIC`: Returns campaign metadata  only.\n- `PROGRESS`: Returns campaign metadata and current campaign progress information."
          }
        ],
        "tags": [
          "Campaigns"
        ]
      },
      "patch": {
        "summary": "Update Campaign by ID",
        "description": "Update an individual campaign. Specify only the properties you want to update. Properties you omit remain unchanged.",
        "operationId": "DSP_UpdateCampaign",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Campaign"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.DSP.UpdateCampaignBody"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Campaigns"
        ]
      }
    },
    "/creative_categories": {
      "get": {
        "summary": "List Creative Categories",
        "description": "Returns a list of creative categories available on the DSP.",
        "operationId": "DSP_ListCreativeCategories",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.ListCreativeCategoriesResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64",
              "minimum": 0,
              "maximum": 100,
              "default": 25
            },
            "description": "The maximum number of results to return per page."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "The zero-based page offset (page number ) to return. For example, 0 returns the first page, 1 returns the second page, and so on."
          },
          {
            "name": "order",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "asc",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean"
            }
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "The field to filter by. You can specify multiple filter parameters.\n\nWhen you apply filters to different fields, the results include only records that match all specified field values (AND logic). When you apply multiple filters to the same field, the results include records that match any of the specified values in that field (OR logic).\n\nSupported Fields: `id`",
            "example": "id:000lYW0SSFSPuV32udyVpA"
          },
          {
            "name": "search",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "Performs a substring search on a specified field. The search is case-insensitive.\n\nSupported Fields: `name`",
            "example": "name:cosmetics"
          }
        ],
        "tags": [
          "Creatives"
        ]
      }
    },
    "/creative_categories/{id}": {
      "get": {
        "summary": "Get Creative Category by ID",
        "description": "Retrieves an individual creative category.",
        "operationId": "DSP_GetCreativeCategory",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CreativeCategory"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "tags": [
          "Creatives"
        ]
      }
    },
    "/creatives": {
      "get": {
        "summary": "List Creatives",
        "description": "Returns the list of creatives available for the current DSP seat.",
        "operationId": "DSP_ListCreatives",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.ListCreativesResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too many requests. Your API call frequency has exceeded limits.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 10,
              "minimum": 0,
              "maximum": 100
            },
            "description": "The maximum number of results to return per page."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0,
              "minimum": 0
            },
            "description": "The zero-based page offset (page number ) to return. For example, 0 returns the first page, 1 returns the second page, and so on."
          },
          {
            "name": "order",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            },
            "description": "The field to sort the results by.\n\nSupported fields: `create_time`, `name`."
          },
          {
            "name": "asc",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean"
            },
            "description": "Specifies the sort direction. Set to `true` for ascending order or `false` for descending order."
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "The field to filter by. You can specify multiple filter parameters.\n\nWhen you apply filters to different fields, the results include only records that match all specified field values (AND logic). When you apply multiple filters to the same field, the results include records that match any of the specified values in that field (OR logic).\n\nSupported fields: `id`, `archived`, `campaign_ids`, `insertion_order_ids`, `advertiser_id`.",
            "example": "advertiser_id:SjZn7_mdSxyReVarigUV9g"
          },
          {
            "name": "search",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "Performs a substring search on a specified field. The search is case-insensitive.\n\nSupported fields: `name`.",
            "example": "name:my_asset.jpg"
          },
          {
            "name": "view",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "BASIC",
                "AUDIT"
              ],
              "default": "BASIC"
            },
            "description": "Specifies which fields are returned in the response.\n\nAvailable views:\n\n- `BASIC`: Returns creative metadata only.\n- `AUDIT`: Returns creative metadata and approval status."
          }
        ],
        "tags": [
          "Creatives"
        ]
      },
      "post": {
        "summary": "Create Creatives",
        "description": "Create Creatives",
        "operationId": "DSP_CreateCreatives",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CreateCreativesResponse"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.CreateCreativesRequest"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Creatives"
        ]
      },
      "patch": {
        "summary": "Update Creatives",
        "description": "Update up to 100 creatives in a single request. Specify only the properties you want to update. Properties you omit remain unchanged.\n\nThis endpoint is transactional. If the request succeeds, all creatives are updated. If the request fails, no creatives are updated.",
        "operationId": "DSP_UpdateCreatives",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.UpdateCreativesResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too many requests. Your API call frequency has exceeded limits.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.UpdateCreativesRequest"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Creatives"
        ]
      }
    },
    "/creatives/{id}": {
      "get": {
        "summary": "Get Creative by ID",
        "description": "Returns an individual creative.",
        "operationId": "DSP_GetCreative",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Creative"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too many requests. Your API call frequency has exceeded limits.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "view",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "BASIC",
                "AUDIT"
              ],
              "default": "BASIC"
            }
          }
        ],
        "tags": [
          "Creatives"
        ]
      },
      "patch": {
        "summary": "Update Creative by ID",
        "description": "Update an individual creative. Specify only the properties you want to update. Properties you omit remain unchanged.",
        "operationId": "DSP_UpdateCreative",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.Creative"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "Invalid request. One or more request parameters are invalid. See the response for more details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too many requests. Your API call frequency has exceeded limits.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/api.dsp.v1.DSP.UpdateCreativeBody"
              }
            }
          },
          "required": true
        },
        "tags": [
          "Creatives"
        ]
      }
    },
    "/insertion_orders": {
      "get": {
        "summary": "List Insertion Orders",
        "description": "Returns a list of the seat’s insertion orders, optionally with progress information.",
        "operationId": "DSP_ListInsertionOrders",
        "responses": {
          "200": {
            "description": "Operation completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.ListInsertionOrdersResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The request contains invalid syntax or encoding.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Not authorized. Authentication is required to access the requested resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Not authenticated. Re-authenticate to access the API.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested resource doesn't exist.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid Request",
                      "data": [
                        {
                          "field": "page",
                          "messages": [
                            "Is not less than or equal to 100"
                          ]
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Too Many Requests"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "The maximum number of results to return per page."
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "The zero-based page offset (page number ) to return. For example, 0 returns the first page, 1 returns the second page, and so on."
          },
          {
            "name": "order",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            },
            "description": "The field to sort the results by."
          },
          {
            "name": "asc",
            "in": "query",
            "required": false,
            "schema": {
              "type": "boolean"
            },
            "description": "Specifies the sort direction. Set to `true` for ascending order or `false` for descending order."
          },
          {
            "name": "filter",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "The field to filter by. You can specify multiple filter parameters.\n\nWhen you apply filters to different fields, the results include only records that match all specified field values (AND logic). When you apply multiple filters to the same field, the results include records that match any of the specified values in that field (OR logic).\n\nSupported Fields: `id`, `archived`, `insertion_order_id`, `region_code`, `active`, `pacing`, `buy_type`\n\nSpecial Filters: `in_flight`: When `true`, limits results to insertion orders where the current time falls between `start_time` and `end_time`.",
            "example": "in_flight:true"
          },
          {
            "name": "search",
            "in": "query",
            "required": false,
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "description": "Performs a substring search on a specified field. The search is case-insensitive.\n\nSupported Fields: `name`",
            "example": "name:new%20york"
          },
          {
            "name": "view",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "BASIC",
                "PROGRESS"
              ],
              "default": "BASIC"
            },
            "description": "Specifies which fields are returned in the response.\n\nAvailable Views:\n\n- `BASIC`: Returns insertion order metadata  only.\n- `PROGRESS`: Returns insertion order metadata and current insertion order progress information."
          }
        ],
        "tags": [
          "Insertion Orders"
        ]
      },
      "post": {
        "summary": "Create Insertion Orders",
        "description": "Create up to 100 new insertion orders in a single request.\n\nThis endpoint is transactional. If the request succeeds, all insertion orders are created. If the request fails, no insertion orders are created.",
        "operationId": "DSP_CreateInsertionOrders",
        "responses": {
          "200": {
            "description": "A successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.dsp.v1.CreateInsertionOrdersResponse"
                }
              }
            }
          },
          "400": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Invalid JSON"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authorized"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Authenticated"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/api.external.lib.v1.Error"
                },
                "examples": {
                  "response": {
                    "value": {
                      "message": "Not Found"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "",
            "content": {
              "application/json": {
[...]
